//  Copyright (c) 2007 GreyCastle Design Company.  All rights reserved.
// Handles formatting XML HTTP requests and responses

var curObject;   // remember ourselves during Async operations

function initXmlHttp(xmlhttp)
{
    xmlhttp.abort();    // abort any outstanding request
    xmlhttp.onreadystatechange=state_Change;
    this.rootNode=null;
}
        
// main 'export' object - contains methods for issuing HTTP calls
function xmlHttpClient(URL)
{
    // first define the 'public api'
    this.debugging=false;
    this.lastFailure=false;
    this.notifyCallback = nullNotifyFunction;
    this.URL = URL; // restrict an object to a single server connection
    this.xmlobj = null;

    // create new xmlhttp object
    this.xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    // perform request
    this.GET = function(queryString,avoidCache)
    {
        // form request string
        var xmlRequest = this.URL+queryString;
        if ((typeof(avoidCache)!='undefined') && (avoidCache==true))
        {
            // if request already has a querystring we just tack on our parm
            if (xmlRequest.indexOf('?')==-1)
            {
                // form a randomized URL to defeat possible IE caching
                xmlRequest = xmlRequest + "?sid=" + Math.random();
            }
            else  // add parm only
            {
                // form a randomized URL to defeat possible IE caching
                xmlRequest = xmlRequest + "+sid=" + Math.random();
            }
        }
        // send it
        this.httpSend("GET",xmlRequest);
    };
    this.POST = function(queryString)
    {
        // form request string
        var xmlRequest = this.URL+queryString;
        // send it
        this.httpSend("POST",xmlRequest);
    };
    this.httpSend = function(op,xmlRequest)
    {
        if (this.debugging)
        {
            alert("httpSend "+op);
        }
        // save ourselves for later
        curObject = this;
        // (re)init xmlhttp object
        initXmlHttp(this.xmlhttp);
        
        // form request string
        this.lastFailure=false;
        if (this.debugging)
        {
            alert("sending: "+xmlRequest);
        }
        // open connection to server
        this.xmlhttp.open(op,xmlRequest,true);
        // process transaction
        this.xmlhttp.send(null);
    };
}

// this is the default (do nothing) forecast callback
// NOTE: it is not an xmlHTTP object method
function nullNotifyFunction()
{
}

// this xmlhttp event handler updates the
// forecast array and calls the notify function
function state_Change()
{
    if (curObject.debugging)
    {
        alert("http state change:"+curObject.xmlhttp.readyState);
    }
    // if xmlhttp shows "loaded"
    if (curObject.xmlhttp.readyState==4)
    {
        // if "OK"
        if (curObject.xmlhttp.status==200)
        {
            if (curObject.debugging)
            {
                  alert("Status: "+curObject.xmlhttp.statusText);
                  alert("ResponseText: "+curObject.xmlhttp.responseText);
            }
            // delete any leftover object
            if (typeof(curObject.xmlobj) == 'object')
            {
                delete curObject.xmlobj;
            }
            curObject.xmlobj=new ActiveXObject("Microsoft.XMLDOM");
            curObject.xmlobj.async="false";
            curObject.xmlobj.loadXML(curObject.xmlhttp.responseText);
        }
        else    // HTTP status not "OK"
        {
            if (curObject.debugging)
            {
                alert("HTTP Error Status: "+curObject.xmlhttp.status);
                alert("Error Response: "+curObject.xmlhttp.statusText);
            }
            curObject.lastFailure=true;  // indicate update failure
        }
        // perform notify
        if (curObject.debugging)
        {
            alert("xmlHTTP notify calling:\n"+curObject.notifyCallback.toString());
        }
        curObject.notifyCallback(curObject);
    }
}
